VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Serials"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Description = "Genera un nmero de serie basado en otro nmero que se ingresa al crear la instancia a esta clase."
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit
'redim preserve MiIDaCodificar
Private Serial_Producto As String
Private Serial_Envio As String
Private Serial_Inicio As String
Public MiIDaCodificar As String

'Valores para el clculo del nmero de serie final y de envo.
Public Enum Numero_Magico
    Agustin = 30111979
    Silvia = 15111980
End Enum

'Valores para determinar si cuando se crea la clase, se basa en un nmero
'codificado (o sea, ya tratado antes por esta clase), o en uno nuevo.
Public Enum Serial_Tipo
    SerialParaCodificar = 1
    SerialCodificado = 2
End Enum
Public MiIDaCodificarTipo As Boolean




'Toma por valor un nmero para tratar de crear otro que sirve de Serial.
Public Sub Inicio(ByVal strSerial As String, Optional ByVal Tipo As Serial_Tipo = SerialParaCodificar)
If MiIDaCodificar = "" Then  '"0123456789ABCDEF"
        If Tipo = SerialParaCodificar Then              'Si el nmero es nuevo.
            Serial_Inicio = strSerial
        Else                                            'Si el nmero est codificado.
           Serial_Inicio = Decodificar(strSerial)
        End If
Else
   If MiIDaCodificarTipo = False Then
        Serial_Inicio = Decodificar(MiIDaCodificar)
   Else
        Serial_Inicio = Val(MiIDaCodificar)
   End If
End If
'
'Almacena los datos en las variables a partir de Serial_Inicio.
    Serial_Envio = Codificar(Agustin)
    Serial_Producto = Codificar(Silvia)
End Sub


'Devuelve el Serial creado para el Producto.
Public Function serial() As String
    serial = Serial_Producto
End Function


'Devuelve un serial que se utilizar para ser enviado por mail.
Public Function SerialDeEnvio() As String
    SerialDeEnvio = Serial_Envio
End Function


Private Function Codificar(Optional ByVal lngNum As Numero_Magico = Agustin) As String
    Dim lngVar As Double
    'Le hacemos a lngVar varios cambios (cualquiera, pero despus hay que
    'buscar su funcin inversa para decodificarlo).
    'Ejemplo: le sumo mis fecha (en valor real) de cumpleaos y
    'comvierto todo a hexadecimal.
    lngVar = CDbl(Serial_Inicio) + lngNum
    'Llama a la funcin para crear el nmero de serie.
    Codificar = Hex(lngVar)
End Function


Private Function Decodificar(ByVal strSerial As String, Optional ByVal lngNum As Numero_Magico = Agustin) As String
    Dim lngVar As Double
    'Hacemos la regla inversa de la funcin Codificar.
    'Convertimos en real el nmero hexadecimal y le restamos el nmero mgico.
    lngVar = (Val("&H" & strSerial) - lngNum)
    Decodificar = Str(lngVar)
End Function



